# coding: utf-8

"""
    Component Database API

    The API that provides access to Component Database data.  # noqa: E501

    The version of the OpenAPI document: 3.15.8
    Contact: djarosz@anl.gov
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from cdbApi.configuration import Configuration


class Attachment(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'original_filename': 'str',
        'tag': 'str',
        'description': 'str',
        'log_list': 'list[Log]',
        'property_value_list': 'list[PropertyValue]',
        'file_path': 'str',
        'display_name': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'original_filename': 'originalFilename',
        'tag': 'tag',
        'description': 'description',
        'log_list': 'logList',
        'property_value_list': 'propertyValueList',
        'file_path': 'filePath',
        'display_name': 'displayName'
    }

    def __init__(self, id=None, name=None, original_filename=None, tag=None, description=None, log_list=None, property_value_list=None, file_path=None, display_name=None, local_vars_configuration=None):  # noqa: E501
        """Attachment - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._original_filename = None
        self._tag = None
        self._description = None
        self._log_list = None
        self._property_value_list = None
        self._file_path = None
        self._display_name = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        if original_filename is not None:
            self.original_filename = original_filename
        if tag is not None:
            self.tag = tag
        if description is not None:
            self.description = description
        if log_list is not None:
            self.log_list = log_list
        if property_value_list is not None:
            self.property_value_list = property_value_list
        if file_path is not None:
            self.file_path = file_path
        if display_name is not None:
            self.display_name = display_name

    @property
    def id(self):
        """Gets the id of this Attachment.  # noqa: E501


        :return: The id of this Attachment.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Attachment.


        :param id: The id of this Attachment.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Attachment.  # noqa: E501


        :return: The name of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Attachment.


        :param name: The name of this Attachment.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 128):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def original_filename(self):
        """Gets the original_filename of this Attachment.  # noqa: E501


        :return: The original_filename of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._original_filename

    @original_filename.setter
    def original_filename(self, original_filename):
        """Sets the original_filename of this Attachment.


        :param original_filename: The original_filename of this Attachment.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                original_filename is not None and len(original_filename) > 256):
            raise ValueError("Invalid value for `original_filename`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                original_filename is not None and len(original_filename) < 1):
            raise ValueError("Invalid value for `original_filename`, length must be greater than or equal to `1`")  # noqa: E501

        self._original_filename = original_filename

    @property
    def tag(self):
        """Gets the tag of this Attachment.  # noqa: E501


        :return: The tag of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this Attachment.


        :param tag: The tag of this Attachment.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                tag is not None and len(tag) > 64):
            raise ValueError("Invalid value for `tag`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                tag is not None and len(tag) < 0):
            raise ValueError("Invalid value for `tag`, length must be greater than or equal to `0`")  # noqa: E501

        self._tag = tag

    @property
    def description(self):
        """Gets the description of this Attachment.  # noqa: E501


        :return: The description of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Attachment.


        :param description: The description of this Attachment.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 256):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501

        self._description = description

    @property
    def log_list(self):
        """Gets the log_list of this Attachment.  # noqa: E501


        :return: The log_list of this Attachment.  # noqa: E501
        :rtype: list[Log]
        """
        return self._log_list

    @log_list.setter
    def log_list(self, log_list):
        """Sets the log_list of this Attachment.


        :param log_list: The log_list of this Attachment.  # noqa: E501
        :type: list[Log]
        """

        self._log_list = log_list

    @property
    def property_value_list(self):
        """Gets the property_value_list of this Attachment.  # noqa: E501


        :return: The property_value_list of this Attachment.  # noqa: E501
        :rtype: list[PropertyValue]
        """
        return self._property_value_list

    @property_value_list.setter
    def property_value_list(self, property_value_list):
        """Sets the property_value_list of this Attachment.


        :param property_value_list: The property_value_list of this Attachment.  # noqa: E501
        :type: list[PropertyValue]
        """

        self._property_value_list = property_value_list

    @property
    def file_path(self):
        """Gets the file_path of this Attachment.  # noqa: E501


        :return: The file_path of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._file_path

    @file_path.setter
    def file_path(self, file_path):
        """Sets the file_path of this Attachment.


        :param file_path: The file_path of this Attachment.  # noqa: E501
        :type: str
        """

        self._file_path = file_path

    @property
    def display_name(self):
        """Gets the display_name of this Attachment.  # noqa: E501


        :return: The display_name of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this Attachment.


        :param display_name: The display_name of this Attachment.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Attachment):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Attachment):
            return True

        return self.to_dict() != other.to_dict()
